package hk.advanpro.android;

import android.content.Context;
import android.support.test.InstrumentationRegistry;
import android.support.test.runner.AndroidJUnit4;
import android.util.Log;

import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.Date;

import hk.advanpro.android.core.AdvanproCore;
import hk.advanpro.android.core.config.AdvanproCoreConfig;
import hk.advanpro.android.core.log.ALogger;
import hk.advanpro.android.core.raw.RawDataFile;
import hk.advanpro.android.core.utils.FileUtils;
import hk.advanpro.android.core.utils.SystemUtils;

import static org.junit.Assert.assertTrue;

/**
 * Instrumentation test, which will execute on an Android device.
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
@RunWith(AndroidJUnit4.class)
public class ExampleInstrumentedTest {
    static Context appContext;

    @BeforeClass
    public static void useAppContext() throws Exception {
        // Context of the app under test.
        appContext = InstrumentationRegistry.getTargetContext();
        AdvanproCore.initWithConfig(new AdvanproCoreConfig(InstrumentationRegistry.getTargetContext(), true));
    }

    @Test
    public void testFileUtils() throws Exception {
        FileUtils fileUtils = new FileUtils();
        String externalFilesDir = SystemUtils.getExternalFilesDir(appContext);
        Log.d("ExampleInstrumentedTest", "externalFilesDir=" + externalFilesDir);
        boolean write = fileUtils.write("test\t111111\n", externalFilesDir + "/ddddd.txt");
        assertTrue(write);
    }

    @Test
    public void testLog() {
        Log.i("ExampleInstrumentedTest", "testLog start");
        ALogger.getInstance().setMaxLineCount(1000);
        for (int i = 0; i < 1000 * 2; i++) {
            boolean b = ALogger.d("ExampleInstrumentedTest", ALogger.KEY_START, String.valueOf(i), ALogger.KEY_URL, "urlurl");
            assertTrue(b);
        }
        Log.i("ExampleInstrumentedTest", "testLog end");

    }

    @Test
    public void testRaw() {
        Log.i("ExampleInstrumentedTest", "testRaw start");
        RawDataFile file = RawDataFile.getR2("RawTestFile", "1", new Date());
        for (int i = 0; i < 1000 * 2; i++) {
            boolean b = file.put(ALogger.KEY_START, String.valueOf(i), ALogger.KEY_URL, "urlurl");
            assertTrue(b);
        }
        Log.i("ExampleInstrumentedTest", "testRaw end");

    }
}
