package hk.advanpro.android.core.utils;

import android.content.Context;
import android.content.SharedPreferences;

import java.util.Calendar;

import hk.advanpro.android.core.AdvanproCore;

import static android.content.Context.MODE_PRIVATE;

/**
 * Created by jalin on 2017/12/7.
 */

public class SharedPreferencesUtils {

    SharedPreferences sp;
    private static SharedPreferencesUtils instance;

    public static SharedPreferencesUtils getInstance() {
        if (instance == null) {
            instance = new SharedPreferencesUtils(AdvanproCore.getAppContext(), "advanpro-default");
        }
        return instance;
    }

    public SharedPreferencesUtils(Context context, String name) {
        sp = context.getSharedPreferences(name, MODE_PRIVATE);
    }

    public void putString(String key, String value) {
        sp.edit().putString(key, value).apply();
    }


    public void putInt(String key, int value) {
        sp.edit().putInt(key, value).apply();
    }


    public void putLong(String key, long value) {
        sp.edit().putLong(key, value).apply();
    }


    public void putFloat(String key, float value) {
        sp.edit().putFloat(key, value).apply();
    }

    public void putBoolean(String key, boolean value) {
        sp.edit().putBoolean(key, value).apply();
    }

    //=========get=========

    public String getString(String key) {
        return getString(key, "");
    }

    public String getString(String key, String defaultValue) {
        return sp.getString(key, defaultValue);
    }

    public boolean getBoolean(String key) {
        return getBoolean(key, false);
    }

    public boolean getBoolean(String key, boolean defaultValue) {
        return sp.getBoolean(key, defaultValue);
    }

    public int getInt(String key) {
        return getInt(key, 0);
    }

    public int getInt(String key, int defaultValue) {
        return sp.getInt(key, defaultValue);
    }

    public long getLong(String key) {
        return getLong(key, -1L);
    }

    public long getLong(String key, long defaultValue) {
        return sp.getLong(key, defaultValue);
    }

    public float getFloat(String key) {
        return getFloat(key, -1F);
    }

    public float getFloat(String key, float defaultValue) {
        return sp.getFloat(key, defaultValue);
    }

    public void remove(String key) {
        sp.edit().remove(key).apply();
    }

    public boolean contains(String key) {
        return sp.contains(key);
    }

    public void clear() {
        sp.edit().clear().apply();
    }

    public boolean commit() {
        return sp.edit().commit();
    }
}
